# 目录说明

目录结构 
|-- sdk_web_v3                   //工程项目名称
	|-- build                    //工程运行
	|    |-- shell
	|          |-- win_node_download.bat
	|          |-- mac_node_download.sh 
	|          |-- win_node_https_run.bat
	|          |-- mac_node_https_run.sh	
	|          |-- https_channel_server.js
	|          |-- ssl.crt
	|          |-- ssl.key	
	|          |-- README.md
	|    
	|    |-- tool
	|          |--        
	|
	|-- demo                
	|    |-- common                       
	|          |-- restAPI.js  
	| 
	|    |-- lib 
	|		   |-- aliplayer
  |          		|-- aliplayer-h5-min.js                          
  |          		|-- aliplayer-min.css                          
  |            |-- jquery.min.js                          
  |            |-- cn.tee3.avd-3.5.9.0.min.js  
  |                           
	|    |-- index.html                      
	|    |-- baseVideo                      
	|          |-- css                       
	|          |-- images                   
	|          |-- js                    
	|          |-- index.html                     
	|          |-- README.md                      
	|    |-- screenLive                  
	|
	|-- doc                
	|    |-- AVD SDK Web版开发指南.pdf                       
	|    |-- 接口手册                       
	|
	|-- README.md      //Readme

demo是AVD SDK应用实例,内包含基本音视频实时互动的baseVideo demo、屏幕直播screenLive demo及其它demo样例。 
doc是AVD SDK帮助文档目录，其中API接口开发手册是SDK API的具体描述，可以直接点击目录中的index.html，在浏览器中访问。开发指南是一份的以其实本音视频实时互动的baseVideo demo为范本的开发指南说明。 
build是demo在第三方Web容器运行，尤其在nodejs环境中运行的操作目录，带有nodejs安装文件及运行脚本


## IDE中使用说明
  推荐使用HBilder IDE,直接导入就可以通过内置web服务器运行Demo.具体参阅AVD SDK Web版开发指南。
  因启动的是http服务，因而要确保连的是http服务器地址，可在demo/baseVideo/js/index.js中修改，把serverUrl服务器地址修改为avd.nice2meet.cn:9609(https断开号为9610)
  * 注：`因avd.nice2meet.cn为我们的内部测试服务器，存在不稳定性，只能作为体验用，如需开发调试请自行搭建服务器！`

### 第三方web容器运行
  搭建本地服务器，可以采用第三方web容器，如jboss,nginx,tomcat等工具搭建的服务器，直接把demo整个目录拖入第三方web容器运行即可。
  
  
#### 使用node.js搭建本地服务器
本地 webserver 开启的目的是提供一个 web 环境，让网页位于服务器上。
原因是Chrome要求调用 webrtc 的 getUserMedia 函数的 HTML 文件要放在服务器上，否则调用该函数会得到一个NavigatorUserMediaError 的错误，显示 PermissionDeniedError。
因为Chrome浏览器47及以后版本都要求getUserMedia 必须在https环境下被调用。
采用nodejs搭建本地服务器，可开启https服务，具体调用见build目录下的readme
注：因启动的是https服务，因而要确保连的是https服务器地址，可在demo/baseVideo/js/index.html中修改，把serverUrl服务器地址修改为dev.3tee.cn:441

