var hang = document.querySelector('.hang');
var idle = document.getElementById('idle');
var busy = document.getElementById('busy');
var leave = document.getElementById('leave');
var activexDom = document.getElementById('activexDom');
var userId = document.getElementById('userId');
var inviteBox = document.querySelector('.inviteBox');
var video_dialog = document.getElementById('video_dialog');

var isMeetingOpen = false; //会议开启状态

var activeX, agentId;

var isDraging = false; //是否拖拽

var isshow = false; //是否显示

var setaState = 0;//当前坐席实时状态


function g(id){return document.getElementById(id)};

if (isIE()) {
	var object = document.createElement('object');

	object.setAttribute('id', "DBActiveX");
	object.setAttribute('classid', "clsid:6A0AD65F-67FB-4594-947F-0D3B2FB7E84B");

	activexDom.appendChild(object);
	activeX = document.getElementById("DBActiveX");
	
	setTimeout(function() {
		activeX.hide();
	}, 100);

	var serverURLStr = 'http://'+serverURL;
	console.log("=============serverURLStr:",serverURLStr);
	console.log("=============opions:",getCookie('opions'));

	activeXCallBack();
	activeX.setLoginfo(3);   //音视频SDK日志级别开关项，0:none, 1:error ,2:warning,3:info,4:verbose,5:sensitive
	activeX.setUILog(true);  //ActiveX控件UI日志开关项

	//用于设置登录时向服务器发送json消息的三个参数 
	var dataSource = 'jsDSTest'; //数据渠道
	var backInfo = 'jsBITest'; //预留信息
	var userinfo = 'jsUITest'; //用户预留信息
	activeX.setLoginOptions(dataSource,backInfo,userinfo);

	activeX.login(getCookie('agentId'),getCookie('agentName'),serverURLStr,accessKey,secretKey,getCookie('opions'),15);
	initVideobackgroudView();
	isshow = false;   
    
}

//回调
function activeXCallBack() {
	activeX.attachEvent("onMeetingStatus", onMeetingStatus);
	activeX.attachEvent("onInviteAccept", onInviteAccept);
	activeX.attachEvent("onInviteCall", onInviteCall);
	activeX.attachEvent("onLogInit", onLogInit);
	activeX.attachEvent("onLogin", onLogin);
	activeX.attachEvent("onLogout", onLogout);
	activeX.attachEvent("onUserJoin", onUserJoin);
	activeX.attachEvent("onUserLeave", onUserLeave);
	activeX.attachEvent("onSeatStatus", onSeatStatus); //0(空闲)/1(忙碌)
	activeX.attachEvent("onInviteClose", onInviteClose); //远端挂断回调 
	activeX.attachEvent("onInviteCancel", onInviteCancel);
	activeX.attachEvent("onInviteTimeOut", onInviteTimeOut);
}

if (getCookie('agentId') != '') {
	agentId = getCookie('agentId');
	$('#userMsg').html(getCookie('agentId'));

} else {
	window.location.href = './index.html'
}

//
/**
 * 会议状态更新通知
 * @param {*} agentid 
 * @param {*} status 0:初始状态，1：正在连接，2：已经连接，3：连接失败
 */
function onMeetingStatus(agentid, status){
	console.log('onMeetingStatus(), agentid:',agentid + ',status:',status)
	if(status == 1) {
		$('#anError').html('正在连接...');
	} else if (status == 2) {
		$('#anError').html('连接成功');
		$('#anError').css({
			color: ''
		})
		setTimeout(function(){
			$('#anError').html('');
		},3000)
	} else if (status == 3) {
		$('#anError').html('连接失败');
	}
}

//退出
function buttonShow() {
	var exitAffirm = document.querySelector('.exitAffirm');
	exitAffirm.style.display = 'block';
}

//确认退出
function confirmExit() {
	document.cookie = 'agentId=';
	document.cookie = 'agentName=';
	document.cookie = 'opions=';
	hangUp();
	activeX.logout();
	window.history.back(-1);
}

//取消退出
function cancelExit() {
	var exitAffirm = document.querySelector('.exitAffirm');
	exitAffirm.style.display = 'none';
}

//邀请接受回调
function onInviteAccept(code, message){
    if(code == 0) {
        console.log('=========onJoinResult() 加会成功');
    } else {
        console.log('=========onJoinResult() 加会失败,message:',message);
        activeX.leaveRoom(0);
        $('.callMsg span').html('');
        $('.callMsg').css({ 'display': 'none' });
        $('.hang').css({ 'display': 'none' });
        
    	video_dialog.style.display = 'none';
        g('mask').style.display = 'none';

		activeX.hide();
		isshow = false;
        isMeetingOpen = false;
    }
}

function onInviteClose(fromId, reson) {
	console.log("=============onInviteClose(),fromid:", fromId);
	$('.callMsg span').html(fromId + '已挂断');

	activeX.hide();
	$('.callMsg').css({ 'display': 'none' });
	$('.hang').css({ 'display': 'none' });
	isshow = false;
	isMeetingOpen = false;
    video_dialog.style.display = 'none';
	g('mask').style.display = 'none';
	
	if(setaState == 2) {
		activeX.leaveRoom(0);
	}
}

//挂断
function hangUp() {
	if(setaState == 2) {
		activeX.leaveRoom(0);
		activeX.inviteClose("hangUp");
	}
	
	$('.callMsg span').html('');
	$('.callMsg').css({ 'display': 'none' });
    $('.hang').css({ 'display': 'none' });
    
    video_dialog.style.display = 'none';
	g('mask').style.display = 'none';

	activeX.hide();
	isMeetingOpen = false;
}

//日志回调
function onLogInit(code, message) {
	console.log('onLogInit')
	if (code == 0) {
		console.log('onLogInit, logPath:', message);
	} else {
		console.log('onLogInit, error:', message);
	}
}

//登录成功回调
function onLogin(code, message) {
	if (code == 0) {
		console.log('路由注册成功');
		$('#anError').html('');
	} else if (code == -2) {
		console.log('重连中,message:', message);
		$('#anError').html('重连中...');
	} else {
		console.log('路由注册失败，message:', message);
		$('#anError').html('路由注册失败,message:' + message);
	}
}

//登出成功回调
function onLogout(code, message) {
	if (code == 0) {
		console.log('路由注消成功');
	} else {
		console.log('路由注消失败，message:', message);
		$('#anError').html('路由注消失败,message:' + message);
	}
}

//客户端加会回调
function onUserJoin(userId, userName) {
	console.log('onUserJoin(),userId:', userId, ",userName:", userName);
	$('.callMsg span').html('与' + userId + '通话中');
	$('.callMsg').css({ 'display': 'block' });
	$('.hang').css({ 'display': 'block' });
	isMeetingOpen = true;
}

//客户端退会回调
function onUserLeave(userId, userName, type) {
	console.log('onUserLeave(),userId:', userId, ",userName:", userName, ",type:", type);
	if (type == 0) {
		console.log('正常退会');
		activeX.leaveRoom(0);
		activeX.hide();
		video_dialog.style.display = 'none';
		g('mask').style.display = 'none';
		isshow = false;
	} else if (type == 812) {
		console.log('异常退会');
		activeX.leaveRoom(0);
		activeX.inviteClose("hangUp");
        activeX.hide();
		video_dialog.style.display = 'none';
		g('mask').style.display = 'none';
		isshow = false;
	}

	$('.callMsg span').html('');
	$('.callMsg').css({ 'display': 'none' });
	$('.hang').css({ 'display': 'none' });
	isMeetingOpen = false;
}


//控制坐席状态
function controlSeatState(){
	//空闲状态立即离席，忙碌状态下次空闲时离席生效
	if(setaState == 0 || setaState == 2){
		console.log('======controlSeatState()setaState:', setaState);
		activeX.acdSetSeatLeave();
		return;
	}

	//只有离席状态才能回席
	if(setaState == 1){
		activeX.acdSetSeatBack();
		return;
	}
}

/**
 * 坐席状态回调 
 * @param {*} account 
 * @param {*} status 0:坐席空闲，1：坐席离席，2：坐席忙碌，3：坐席离线
 */
function onSeatStatus(account, status) {
	console.log(' onSeatStatus  account', account, ',status:',status);
	setaState = status;
	if(status == 0) {
		idle.style.display = 'block';
		leave.style.display = 'none';
		busy.style.display = 'none';
		$('.state span').html('空闲');
	} else if(status == 1){
		idle.style.display = 'none';
		leave.style.display = 'block';
		busy.style.display = 'none';
		$('.state span').html('离席');
	} else if(status == 2){
		leave.style.display = 'none';
		idle.style.display = 'none';
		busy.style.display = 'block';
		$('.state span').html('忙碌');
	}
}

function menuShow(dom) {
	var menuDom = document.getElementById(dom);
	var menuDomShow = menuDom.style.display;
	if (menuDomShow == 'none') {
		menuDom.style.display = 'block';
	} else {
		menuDom.style.display = 'none';
	}
}

//接受邀请
function inviteAccept() {
	console.log('inviteAccept()');
	
	video_dialog.style.display = 'block';
	activeX.show();
	activexDom.style.top = '50%';
	activexDom.style.left = '50%';
	g('mask').style.display = 'block';
	autoCenter(g('video_dialog'));
	activeX.inviteAccept();
	activeX.forceRefresh();
	inviteBox.style.display = 'none';
	isshow = true;
}

//拒绝邀请
function inviteReject() {
	console.log('inviteReject()');
	activeX.inviteReject();
	activeX.hide();
	inviteBox.style.display = 'none';
	video_dialog.style.display = 'none';
	isshow = false;
}

//邀请回调
function onInviteCall(id, name) {
	console.log('onInviteCall(), id:', id);
	$('#userId').html(id);
	inviteBox.style.display = 'block';
}

//远端取消邀请回调
function onInviteCancel(userId, message) {
	console.log('onInviteCancel(),userId:', userId,',message:',message);
	inviteBox.style.display = 'none';
	video_dialog.style.display = 'none';
	activeX.hide();
	isMeetingOpen = false;
	$('.callMsg span').html('');
	$('.callMsg').css({ 'display': 'none' });
	$('.hang').css({ 'display': 'none' });
	g('mask').style.display = 'none';
}

//超时回调
function onInviteTimeOut(userId, message){
	console.log('onInviteTimeOut(),userId:', userId,',message:',message);
	inviteBox.style.display = 'none';
}

//触发的二种情况：
// 1)点浏览器的X退出时会触发
// 2)点页面刷时先触发onbeforeunload,再触发onunload
window.onbeforeunload = function (event) {
	console.log("=======onbeforeunload");
	if (isMeetingOpen) {
		hangUp();
		sleep(5000);
		activeX.logout();
	} else {
		activeX.logout();
	}

	//解决关闭IE时，由于音视频引擎未析构引起的IE残留问题
	activeX.releaseEngine();
	sleep(1000);
}

function sleep(numberMillis) {
	var now = new Date();
	var exitTime = now.getTime() + numberMillis;
	while (true) {
		now = new Date();
		if (now.getTime() > exitTime)
			return;
	}
}


/**
 *初始化视频弹出窗口
 */
function initVideobackgroudView(){
    //禁止选中对话框内容
    //ie的事件监听，拖拽div时禁止选中内容
    if (document.attachEvent) {
        g('video_dialog').attachEvent('onselectstart', function() {
            return false;
        });
    }
    //声明需要用到的变量
    var mx = 0,my = 0;      //鼠标x、y轴坐标（相对于left，top）
	var cx = 0,cy = 0;
    var dx = 0,dy = 0;      //对话框坐标（同上）

    g('move_part').addEventListener('mousedown',function(e){
        var e = e || window.event;
        mx = e.pageX;      //点击时鼠标X坐标
        my = e.pageY;      //点击时鼠标Y坐标
		cx = mx;
		cy = my;
		g_screenx = e.screenX;
		g_screeny = e.screenY;
		g_clientx = e.clientX;
		g_clienty = e.clientY;
		
        dx = g('video_dialog').offsetLeft;
        dy = g('video_dialog').offsetTop;
        isDraging = true;      //标记对话框可拖动
    });
    document.onmousemove = function(e){
        var e = e || window.event;
        var x = e.pageX;      //移动时鼠标X坐标
        var y = e.pageY;      //移动时鼠标Y坐标

		g_screenx = e.screenX;
		g_screeny = e.screenY;
		g_clientx = e.clientX;
		g_clienty = e.clientY;
		
        if(isDraging){        //判断对话框能否拖动
            var moveX = dx + x - mx + 300;      //移动后对话框新的left值
            var moveY = dy + y - my + 290;      //移动后对话框新的top值
           
            var pageW = document.documentElement.clientWidth;
            var pageH = document.documentElement.clientHeight;
            var dialogW = g('video_dialog').offsetWidth;
            var dialogH = g('video_dialog').offsetHeight;
            var maxX = pageW - dialogW + 300;       
            var maxY = pageH - dialogH + 290;       
            moveX = Math.min(Math.max(300,moveX),maxX);    
            moveY = Math.min(Math.max(290,moveY),maxY);    

            g('video_dialog').style.left = (moveX+10) +'px';       
            g('video_dialog').style.top =  (moveY+10) +'px';      
			
			var activexDom = document.getElementById('activexDom');
			activexDom.style.left = parseInt(g('video_dialog').style.left)+ 'px';
			activexDom.style.top =  parseInt(g('video_dialog').style.top) +'px';
			var activeX = g('DBActiveX');
			if((cx!= x) || (cy != y)){
				cx = x;
				cy = y;
				activeX.forceRefresh();
			}
        };
    };
//鼠标离开
    g('move_part').addEventListener('mouseup',function(){
        isDraging = false;
        var activeX = g('DBActiveX');
        activeX.forceRefresh();
    });

}

/**
 *音视频弹出窗口居中显示
 */
function autoCenter(el){
    var bodyW = document.documentElement.clientWidth;
    var bodyH = document.documentElement.clientHeight;
    
	if(el.id == "activeXDom"){
		el.style.left = ((bodyW)/2 + 10) + 'px';
		el.style.top = ((bodyH)/2 + 25) + 'px';
	} else {
		el.style.left = (bodyW)/2 + 'px';
		el.style.top = (bodyH)/2 + 'px';
	}
};

/**
 *窗口大小改变时，对话框始终居中
 */
window.onresize = function(){
    autoCenter(g('video_dialog'));
	
	if(isshow){
		autoCenter(g('activexDom'));
		var activeX = g('DBActiveX');
		activeX.forceRefresh();
	}
};

document.addEventListener('mouseup', function(e) {
	if(e.clientY > window.innerWidth || e.clientY<0 || e.clientX<0 ||e.clientX>window.innerHeight){
	  	//在这加入你想执行的代码，此条件下鼠标已经在浏览器外
		isDraging = false;
		var activeX = g('DBActiveX');
		activeX.forceRefresh();
	}
})